From daaf67140214e7f69d145c2f6ba68dbf562e0630 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 721/1001] Convert the github_pr widget


---

diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
new file mode 100644
index 0000000..5478f1c
--- /dev/null
+++ b/hubs/widgets/github_pr/__init__.py
@@ -0,0 +1,94 @@
+from __future__ import unicode_literals
+
+import logging
+import hubs.utils
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+import fedmsg.config
+fedmsg_config = fedmsg.config.load_config()
+
+log = logging.getLogger(__name__)
+
+
+class GitHubPRs(Widget):
+
+    name = "github_pr"
+    position = "right"
+    arguments = [
+        dict(
+            name="organization",
+            label="Organization",
+            default=None,
+            validator=validators.github_organization,
+            help="Github Organization or username",
+        ), dict(
+            name="display_number",
+            label="Number of tickets",
+            default=6,
+            validator=validators.integer,
+            help="How many pull requests to display at max.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/github_pr.html"
+    chrome = panel("Github: Pull Requests")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_prs = GetPRs(instance)
+        org = instance.config["organization"]
+        display_number = int(instance.config["display_number"])
+        context = dict(
+            organization=org,
+            display_number=display_number,
+        )
+        context.update(get_prs())
+        return context
+
+
+class GetPRs(CachedFunction):
+
+    def execute(self):
+        org = self.instance.config["organization"]
+        display_number = int(self.instance.config["display_number"])
+        log.info("Getting GH prs for %r, (%r)" % (org, display_number))
+        token = fedmsg_config.get('github.oauth_token')
+        pulls = []
+        displayed_number = 0
+        more = 0
+        if token:
+            repos = hubs.utils.github_repos(token, org)
+            pulls = sum([
+                list(hubs.utils.github_pulls(token, org, repo))
+                for repo in repos
+            ], [])
+            # Reverse-sort by time (newest-first)
+            pulls.sort(lambda a, b: cmp(b['timestamp'], a['timestamp']))
+
+            # Some hints for display
+            len_pulls = len(pulls)
+            displayed_number = min(display_number, len_pulls)
+            more = max(len_pulls - displayed_number, 0)
+
+        return dict(
+            more=more,
+            pulls=pulls,
+        )
+
+    def should_invalidate(self, message):
+        category = message["topic"].split('.')[3]
+        if category != "github":
+            return False
+        owner = message['msg']['repository']['owner']
+        if 'login' in owner:
+            owner = owner['login']
+        else:
+            owner = owner['name']
+        return owner == self.instance.config['organization']

